app load ["Int"];

(* maxl : int list -> int
   maxl ns = az ns egszlista legnagyobb eleme
*)
fun maxl [] = raise Empty
  | maxl [n] = n
  | maxl (n::ns) = Int.max(n, maxl ns);

(* id : 'a -> 'a
   id x = x
   'a tpusvltozt jell
   id a polimorf (identits)fggvnyt jell, politpus nv
*)
fun id x = x;

(* eq : ''a * ''a -> bool
   eq (x, y) = igaz, ha x s y egyenlk
   ''a : egyenlsgi tpust jell tpusvltoz
*)
fun eq (x, y) = x = y

(* maxl polimorf, generikus vltozata
   maxl max zs = a zs lista max szerint legnagyobb eleme
   maxl : ('a * 'a -> 'a) -> 'a list -> 'a
*)
fun maxl max [] = raise Empty
  | maxl max [z] = z
  | maxl max (z::zs) = max(z, maxl max zs);

(* maxl hatkonyabb vltozata
   maxl max zs = a zs lista max szerint legnagyobb eleme
   maxl : ('a * 'a -> 'a) -> 'a list -> 'a
*)
fun maxl max zs = let fun mxl [] = raise Empty
                        | mxl [y] = y
                        | mxl (y::ys) = max(y, mxl ys)
                  in mxl zs
                  end;

(* if b then "alma" else "citrom" kanonikus vltozata
*)
(fn true => "alma" | false => "citrom") (1<2);
(fn true => "alma" | false => "citrom") (1>2);

(* 1<2 andalso 2<3 kanonikus vltozata
*)
(fn true => (2<3) | false => false) (1<2);

(* 1<2 andalso 2>3 kanonikus vltozata
*)
(fn true => (2>3) | false => false) (1<2);

(* 1>2 andalso 2<3 kanonikus vltozata
*)
(fn true => (2<3) | false => false) (1>2);

(* 1<2 orelse 2<3 kanonikus vltozata
*)
(fn true => (2<3) | false => false) (1<2);

(* 1<2 orelse 2>3 kanonikus vltozata
*)
(fn true => (2>3) | false => false) (1<2);

(* 1>2 orelse 2<3 kanonikus vltozata
*)
(fn true => (2<3) | false => false) (1>2);

(* && s || : moh kirtkels logikai fggvnyek (infix pozciban)
*)

(* && (a, b) = a /\ b
   && : bool * bool -> bool
*)
fun op&& (a, b) = a andalso b;
infix 2 &&;

(* || (a, b) = a \/ b
   || : bool * bool -> bool
*)
fun op|| (a, b) = a orelse b;
infix 1 ||;

(* charMax : char * char -> char 
   charMax (a, b) = a s b kzl a nagyobbik
*)
fun charMax (a, b) = if ord a > ord b then a else b;
fun charMax (a : char, b) = if a > b then a else b;

(* pairMax : ((int * real) * (int * real)) -> (int * real)
   pairMax (n, m) = n s m kzl lexikografikusan a nagyobbik
*)
fun pairMax (n as (n1 : int, n2 : real), m as (m1, m2)) =
      if n1 > m1 orelse n1 = m1 andalso n2 >= m2 then n else m;

(* stringMax : string * string -> string
   stringMax (s, t) = s s t kzl a nagyobbik
*)
fun stringMax (s : string, t) = if s > t then s else t;

(* take : 'a list * int -> 'a list
   take (xs, i) = xs, ha i < 0;
     az xs els i db elembl ll lista, ha i >= 0
*)
fun take (_, 0)     = []
  | take ([], _)    = []
  | take (x::xs, i) = x :: take(xs, i-1);

(* drop : 'a list * int -> 'a list
   drop(xs, i) = xs, ha i < 0;
     az xs els i db elemnek eldobsval elll lista, ha i >= 0
*)
fun drop ([], _)    = []
  | drop (x::xs, i) = if i > 0 then drop (xs, i-1) else x::xs;

take([1,2,3,4,5,6,7,8], 0);
take([1,2,3,4,5,6,7,8], 9);
take([1,2,3,4,5,6,7,8], 4);
take([1,2,3,4,5,6,7,8], ~4);
take([], 1);

drop([1,2,3,4,5,6,7,8], 0);
drop([1,2,3,4,5,6,7,8], 9);
drop([1,2,3,4,5,6,7,8], 4);
drop([1,2,3,4,5,6,7,8], ~4);
drop([], 1);
