
(* app load ["Int", "FileSys"];
*)

FileSys.chDir "/share/polySML";

use "idomero.sml";
use "szamlistak.sml";

(* maxl? : int list -> int
   maxl? ns = az ns egszlista legnagyobb eleme
*)
fun maxl1 [n]     = n
  | maxl1 (n::ns) = Int.max(n, maxl1 ns)
  | maxl1 []      = raise Empty;

fun maxl2 [n]        = n
  | maxl2 (n::m::ns) = maxl2(Int.max(n, m)::ns)
  | maxl2 []         = raise Empty;

fun maxl3 []         = raise Empty
  | maxl3 [n]        = n
  | maxl3 (n::m::ns) = maxl3(Int.max(n, m)::ns);

fun maxl4 [] = raise Empty
  | maxl4 ns = let fun mxl [n]        = n         (* [] esete lefedetlen! *)
		     | mxl (n::m::ns) = mxl(Int.max(n, m)::ns)
	       in mxl ns
	       end;

fun maxl5 []      = raise Empty
  | maxl5 (n::ns) = let fun mxl (m, [])    = m
			  | mxl (m, n::ns) = mxl(Int.max(m, n), ns)
		    in mxl(n, ns)
		    end;

(* maxl? : ('a * 'a -> 'a) * 'a list -> 'a
   maxl? (max, ns) = az ns lista max szerinti legnagyobb eleme
*)
fun maxl6 (max, [])       = raise Empty
  | maxl6 (max, [n])      = n
  | maxl6 (max, n::m::ns) = maxl6(max, max(n, m)::ns);

fun maxl7 (max, []) = raise Empty
  | maxl7 (max, ns) = let fun mxl [n]        = n  (* [] esete lefedetlen! *)
			    | mxl (n::m::ns) = mxl(max(n, m)::ns)
		      in mxl ns
		      end;

fun maxl8 (max, [])    = raise Empty
  | maxl8 (max, n::ns) = let fun mxl (m, [])    = m
			       | mxl (m, n::ns) = mxl(max(m, n),ns)
			 in mxl(n, ns)
			 end;

datatype 'a esetleg = Semmi | Valami of 'a;

(* maxl9 : ('a * 'a -> 'a) * 'a list -> 'a esetleg
   maxl9 (max, ns) = az ns lista max szerinti legnagyobb eleme
*)
fun maxl9 (max, [])    = Semmi
  | maxl9 (max, n::ns) = let fun mxl (m, [])    = Valami m
			       | mxl (m, n::ns) = mxl(max(m, n),ns)
			 in mxl(n, ns)
			 end;

idoiro "maxl1, ns2M: " maxl1 ns2M; (* Out of memory *)
  (* quietdec := true; *)
idoiro "maxl2, ns2M: " maxl2 ns2M;
idoiro "maxl3, ns2M: " maxl3 ns2M;
idoiro "maxl4, ns2M: " maxl4 ns2M;
idoiro "maxl5, ns2M: " maxl5 ns2M;
idoiro "maxl6, ns2M: " maxl6(Int.max, ns2M);
idoiro "maxl7, ns2M: " maxl7(Int.max, ns2M);
idoiro "maxl8, ns2M: " maxl8(Int.max, ns2M);
idoiro "maxl9, ns2M: " maxl9(Int.max, ns2M);
  (* quietdec := false; *)

maxl7(Int.max, [1,3,9,7,4,6,2]) = 9;
maxl8(op+, [1,2,3,4,5,6,7,8,9]) = 45;
maxl9(op*, [1,2,3,4,5,6,7,8,9]) = Valami 362880;


(* maxl10 : ('a * 'a -> 'a) -> 'a list -> 'a esetleg
   maxl10 max ns = az ns lista max szerinti legnagyobb eleme
*)
fun maxl10 max []      = Semmi
  | maxl10 max (n::ns) = Valami(foldl max n ns)

(* maxl11 : ('a * 'a -> 'a) -> 'a list -> 'a esetleg
   maxl11 max ns = az ns lista max szerinti legnagyobb eleme
*)
fun maxl11 max []      = Semmi
  | maxl11 max (n::ns) = Valami(foldr max n ns)

idoiro "maxl10, ns200k, foldl-rel: " maxl10 Int.max ns200k;
idoiro "maxl11, ns200k, foldr-rel: " maxl11 Int.max ns200k;
idoiro "maxl10, ns2M, foldl-rel: "   maxl10 Int.max ns2M;
